#ifndef UPLOADMANAGER_H
#define UPLOADMANAGER_H

#include <list>
#include <string>

#include <qobject.h>

class QtellaSub;
class Upload;
class Push;
class QSocket;
class QTimer;

using namespace std;

class UploadManager : public QObject
{
 Q_OBJECT

 public:
  UploadManager(QtellaSub *parent = 0);
  ~UploadManager();

  void  abortUpload();
  void  removeUpload();
  void  removeInactiveUploads();
  int   numberUploads();

  void  addUpload(std::string data, QSocket* socket);
  void  addPushUpload(Push p);

  QtellaSub*             _parent;
  
 private:
  std::list<Upload*>     upload_list;
  QTimer*                _timer;

 private slots:
  void                   slotTimer();
};

#endif
