#include "Logging.h"
#include "QtellaSub.h"
#include <qlistbox.h>
#include <qdatetime.h>
#include <qcheckbox.h>
#include <qlineedit.h>
#include <qcombobox.h>
#include <iostream>
#include <fstream>

Logging* Logging::_instance = NULL;
QMutex Logging::_mutex;

Logging::Logging()
{
}

Logging* Logging::getInstance()
{
  if(!_instance) _instance = new Logging();
  return _instance;
}

void Logging::log(int loglevel, std::string msg)
{
  _mutex.lock();
  
  QtellaSub* p = QtellaSub::getInstance();

  std::string m = std::string(QTime::currentTime().toString()) + " " + msg;

  if(loglevel == 0) m += "/DEBUG";
  if(loglevel == 1) m += "/INFO";
  if(loglevel == 2) m += "/ERROR";

  if(p->ui_checkbox_enablelogs->isChecked())
    if(loglevel >= p->ui_combobox_loglevel->currentItem())
      {
	p->ui_listbox_logs->insertItem( m.c_str() );
	while(p->ui_listbox_logs->count() > 100) p->ui_listbox_logs->removeItem(0);
	p->ui_listbox_logs->setBottomItem(p->ui_listbox_logs->count()-1);
      }

  if(p->ui_checkbox_loginfile->isChecked())
    if(loglevel >= p->ui_combobox_loglevel->currentItem())
      {
	std::fstream f;
	f.open(p->ui_lineedit_logfile->text(), ios::out|ios::app);
	if(f)
	  {
	    f << m << std::endl;
	    f.close();
	  }
      }

  _mutex.unlock();
}
